Importer.loadQtBinding( "qt.core" );
Importer.loadQtBinding( "qt.gui" );
Importer.loadQtBinding( "qt.uitools" );

var PSString = "";

// function executeCommand extract from PidginSong
// Jason A. Donenfeld
// http://www.kde-apps.org/content/show.php/PidginSong?content=98683
function executeCommand(command, args)
{
	var process = new QProcess();
	process.start(command, args);
	if(process.waitForFinished())
	{
	  	return new QTextStream(process).readAll();
	}
	return false;
}

function setStatus(message)
{
        message = "setstatus?message=" + message;
	executeCommand("purple-remote", [message]);
}

function stringParser(message)
{
    result = message.replace("%t", "titulo");
    return result;
}

function onTrackChange()
{
	var currentTrack = Amarok.Engine.currentTrack();
        result = PSString.replace("%t", currentTrack.title);
        result = result.replace("%a", currentTrack.artist);
        result = result.replace("%A", currentTrack.album);
        result = result.replace("%g", currentTrack.genre);
        result = result.replace("%c", currentTrack.composer);
        result = result.replace("%l", Math.floor(currentTrack.length/60)+":"+ (currentTrack.length % 60) );

        setStatus(encodeURI(result));
}

function onTrackPlayPause(paused)
{
	if(paused)
	{
	   	onTrackFinished();
	}
	else
	{
		onTrackChange();
	}
}

function onTrackFinished()
{
	setStatus("Stoped");
}

function onConfigure()
{
        configWindow.show();
        configWindow.pidginString.text = PSString;
}

function readConfig()
{
        PSString = Amarok.Script.readConfig("PSString","");
}

function saveConfig()
{
        Amarok.Script.writeConfig("PSString", configWindow.pidginString.text);
        PSString = configWindow.pidginString.text;
}

function testFirstRun()
{
    if (Amarok.Script.readConfig("PSFirstRun","") == "")
    {        
        PSString = "[Amarok2] %a - %t";
        Amarok.Script.writeConfig("PSString", PSString);
        Amarok.Script.writeConfig("PSFirstRun", "off");
        return true;
    }
    else
    {
        return false;
    }
}

var cargadorUI = new QUiLoader( this );
var archivoUI = new QFile ( Amarok.Info.scriptPath() + "/config.ui" );
archivoUI.open(QIODevice.ReadOnly);
configWindow = cargadorUI.load(archivoUI, this);
archivoUI.close();
if ( ! testFirstRun() )
{
    readConfig();
}

configWindow.buttonBox.accepted.connect(saveConfig);
configWindow.buttonBox.rejected.connect(readConfig);

Amarok.Engine.trackPlayPause.connect(onTrackPlayPause);
Amarok.Engine.trackChanged.connect(onTrackChange);
Amarok.Engine.trackFinished.connect(onTrackFinished);

Amarok.Window.addSettingsMenu("PidginStatus","Configure PidginStatus");
Amarok.Window.SettingsMenu.PidginStatus.triggered.connect(onConfigure);
